package de.ctdo.bunti.dmx;

public class DMXChannel {
	private int offset;
	private String name;
	private int value;
	private long lastChangedTimestamp = 0;
	
	public DMXChannel(int offset, String name) {
		this.name = name;
		this.offset = offset;
		this.value = 0;
	}

	public int getValue() {
		return value;
	}

	public void setValue(int value) {
		this.value = value;
		lastChangedTimestamp = System.currentTimeMillis();
	}

	public long getLastChangedTimestamp() {
		return lastChangedTimestamp;
	}

	public int getOffset() {
		return offset;
	}

	public void setOffset(int offset) {
		this.offset = offset;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void hasbeenSendOut() {
		this.lastChangedTimestamp = System.currentTimeMillis();
	}
	
	@Override
	public String toString() {
		return "DMXChannel " + getName() + "," + getOffset() + "," + getValue();
	}
	
}
