package de.ctdo.bunti.model;

import de.ctdo.bunti.dmx.DMX;
import de.ctdo.bunti.dmx.DMXChannel;

public class Strobe1500 extends BuntiDMXDevice {
	
	private final static String CHANNEL_SPEED = "speed";
	private final static String CHANNEL_INTENSITY = "intensity";
	private final static String CHANNEL_MODE = "mode";
		
	public Strobe1500(int deviceId, int startAddress, String deviceName) {
		super(deviceId, startAddress, deviceName);
		
		this.dmxChannels.addChannel(new DMXChannel(0, CHANNEL_SPEED));
		this.dmxChannels.addChannel(new DMXChannel(1, CHANNEL_INTENSITY));
		this.dmxChannels.addChannel(new DMXChannel(2, CHANNEL_MODE));
	}
	
	public void setSpeed(int value) {
		setChannelValueByName(CHANNEL_SPEED, value);
	}
	public void setIntensity(int value) {
		setChannelValueByName(CHANNEL_INTENSITY, value);
	}
	public void setMode(int value) {
		setChannelValueByName(CHANNEL_MODE, value);
	}
	public int getSpeed() {
		return getChannelValueByName(CHANNEL_SPEED);
	}
	public int getIntensity() {
		return getChannelValueByName(CHANNEL_INTENSITY);
	}
	public int getMode() {
		return getChannelValueByName(CHANNEL_MODE);
	}
	
	@Override
	public void switchOff() {
		setChannelValueByName(CHANNEL_MODE, DMX.DMX_CHANNEL_VALUE_MIN);
		setChannelValueByName(CHANNEL_SPEED, DMX.DMX_CHANNEL_VALUE_MIN);
		setChannelValueByName(CHANNEL_INTENSITY, DMX.DMX_CHANNEL_VALUE_MIN);
	}

	@Override
	public void switchOn() {
		setChannelValueByName(CHANNEL_MODE, DMX.DMX_CHANNEL_VALUE_MIN);
		setChannelValueByName(CHANNEL_SPEED, DMX.DMX_CHANNEL_VALUE_MAX);
		setChannelValueByName(CHANNEL_INTENSITY, DMX.DMX_CHANNEL_VALUE_MAX);
	}
	
	@Override
	public String toString() {
		return "Strobe1500 " + deviceId + ", " + deviceName +
				"[" + getSpeed() + "," + getIntensity() + "," + getMode() + "]";
	}

}
